# -*- coding: utf-8; -*-
"""
Corporal Web Menus
"""

from tailbone import menus as base
from tailbone_corepos.menus import make_corepos_menu


class CorporalMenuHandler(base.MenuHandler):
    """
    Corporal menu handler
    """

    def make_menus(self, request, **kwargs):

        corepos_menu = make_corepos_menu(request)

        batch_menu = {
            'title': "Batches",
            'type': 'menu',
            'items': [
                {
                    'title': "CORE Member",
                    'route': 'batch.coremember',
                    'perm': 'batch.coremember.list',
                },
                {
                    'title': "Vendor Catalogs",
                    'route': 'vendorcatalogs',
                    'perm': 'vendorcatalogs.list',
                },
            ],
        }

        reports_menu = {
            'title': "Reports",
            'type': 'menu',
            'items': [
                {
                    'title': "New Report",
                    'route': 'report_output.create',
                    'perm': 'report_output.create',
                },
                {
                    'title': "Generated Reports",
                    'route': 'report_output',
                    'perm': 'report_output.list',
                },
                {
                    'title': "Problem Reports",
                    'route': 'problem_reports',
                    'perm': 'problem_reports.list',
                },
                {'type': 'sep'},
                {
                    'title': "Poser Reports",
                    'route': 'poser_reports',
                    'perm': 'poser_reports.list',
                },
            ],
        }

        admin_menu = {
            'title': "Admin",
            'type': 'menu',
            'items': [
                {
                    'title': "Users",
                    'route': 'users',
                    'perm': 'users.list',
                },
                {
                    'title': "User Events",
                    'route': 'userevents',
                    'perm': 'userevents.list',
                },
                {
                    'title': "Roles",
                    'route': 'roles',
                    'perm': 'roles.list',
                },
                {'type': 'sep'},
                {
                    'title': "App Settings",
                    'route': 'appsettings',
                    'perm': 'settings.list',
                },
                {
                    'title': "Email Settings",
                    'route': 'emailprofiles',
                    'perm': 'emailprofiles.list',
                },
                {
                    'title': "Email Attempts",
                    'route': 'email_attempts',
                    'perm': 'email_attempts.list',
                },
                {
                    'title': "Raw Settings",
                    'route': 'settings',
                    'perm': 'settings.list',
                },
                {'type': 'sep'},
                {
                    'title': "Tables",
                    'route': 'tables',
                    'perm': 'tables.list',
                },
                {
                    'title': "Importing / Exporting",
                    'route': 'importing',
                    'perm': 'importing.runjobs',
                },
                {
                    'title': "Corporal Upgrades",
                    'route': 'upgrades',
                    'perm': 'upgrades.list',
                },
            ],
        }

        menus = [
            corepos_menu,
            batch_menu,
            reports_menu,
            admin_menu,
        ]

        return menus
